<script setup lang="ts">
import AppButton from '@/components/ui/AppButton.vue'
import DataTable, { type DataTableColumn } from '@/components/ui/DataTable.vue'
import { client, type Report } from '@/scripts/api-helper'
import { GlobalError, useAppStore } from '@/stores/app'
import { onMounted, onUnmounted, reactive } from 'vue'

const columns: DataTableColumn[] = [
  { name: 'ID', field: 'id' },
  { name: 'Timestamp', field: 'timestamp' },
  { name: 'User ID', field: 'user_id' },
  { name: 'Report Type', field: 'report_type', style: 'flex-center' },
  { name: 'Message', field: 'message' },
  { name: 'Done', field: 'done', style: 'flex-center' }
]

const app = useAppStore()
const state = reactive({
  rows: [] as Report[],
  filteredRows: [] as Report[],
  search: '',
  readyCounter: 0 as number,
  validCounter: 0 as number
})

async function loadReports() {
  const { error, data: reports } = await client.GET('/api/admin/reports', {
    params: {
      query: {
        admin_key: app.adminKey!
      }
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    state.rows = reports
    state.filteredRows = state.rows
  }
}

function updateSearch() {
  if (state.search.length > 0) {
    const q = state.search.toLowerCase()
    state.filteredRows = state.rows.filter((u) => u.message.toLowerCase().includes(q))
  } else {
    state.filteredRows = state.rows
  }
}

let intervalId = -1
onMounted(() => {
  loadReports()
  intervalId = setInterval(updateSearch, 1000)
})

onUnmounted(() => {
  clearInterval(intervalId)
})

async function updateReportStatus(reportId: number, done: boolean) {
  const { error } = await client.POST('/api/admin/report', {
    body: {
      admin_key: app.adminKey!,
      report_id: reportId,
      done
    }
  })
  if (error != null) {
    app.setGlobalError(GlobalError.ActionFailedError)
  } else {
    loadReports()
  }
}
</script>

<template>
  <main id="main">
    <h1 class="mb-3 text-2xl dark:text-white font-semibold">Reports</h1>
    <br />

    <DataTable :columns="columns" :rows="state.filteredRows">
      <template v-slot:toolbar>
        <div
          class="flex flex-col px-4 py-3 space-y-3 lg:flex-row lg:items-center lg:justify-between lg:space-y-0 lg:space-x-4"
        >
          <div class="flex items-center flex-1 space-x-4">
            <h5>
              <span class="text-gray-500">Total: </span>
              <span class="dark:text-white">{{ state.filteredRows.length }}</span>
            </h5>
          </div>
          <div
            class="flex flex-col flex-shrink-0 space-y-3 md:flex-row md:items-center lg:justify-end md:space-y-0 md:space-x-3"
          >
            <input
              v-model="state.search"
              id="password"
              class="bg-gray-50 border border-gray-300 text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
              placeholder="Search in messages"
            />
            <AppButton @click="loadReports">Reload</AppButton>
          </div>
        </div>
      </template>

      <template v-slot:report_type="s">
        <span
          class="bg-blue-100 text-blue-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-blue-900 dark:text-blue-300"
        >
          {{ s.row.report_type }}
        </span>
      </template>

      <template v-slot:done="s">
        <div @click="() => updateReportStatus(s.row.id, !s.row.done)">
          <span
            v-if="s.row.done"
            class="cursor-pointer bg-green-100 text-green-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-green-900 dark:text-green-300"
          >
            Done
          </span>
          <span
            v-else
            class="cursor-pointer bg-red-100 text-red-800 text-xs font-medium me-2 px-2.5 py-0.5 rounded dark:bg-red-900 dark:text-red-300"
          >
            Not done
          </span>
        </div>
      </template>
    </DataTable>
  </main>
</template>
